#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
    int n;
    int k;
    int br;

    long long meta[1000000];

    cin>> n >> k;

    for (int i=0; i<n; i++)
    {
        cin>> meta[i];
    }

    sort(meta, meta + n);

    br=1;

    for(int i=0; i<n-1; i++)
    {
        if(meta[i] == meta[i+1])
        {
            br++;
        }
        else
        {
            br=1;
        }

        if(br == k)
        {
            cout << meta[i] << " ";
        }

    }
    
	return 0;
}